<template>
  <el-form @submit.native.prevent="onSubmit" v-loading="loading">
    <el-row :gutter="24">
      <el-col :span="12">
        <el-form-item label="Name" required>
          <el-input placeholder="Page name" v-model="form.name"></el-input>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="Slug" required>
          <el-input placeholder="Slug" v-model="form.slug"></el-input>
        </el-form-item>
      </el-col>
    </el-row>

    <el-tabs v-model="activeTab" type="border-card" tab-position="left">
      <el-tab-pane
        v-for="(locale, name) in locales"
        :key="locale"
        :label="`${name}`.toUpperCase()"
        :name="locale"
      >
        <div v-if="!form.contents[locale]">
          <el-button type="primary" @click="createTranslation(locale)">
            Create {{ `${name}`.toUpperCase() }} traslation
          </el-button>
        </div>
        <el-tabs type="card" v-else>
          <el-tab-pane label="Page">
            <el-row :gutter="24">
              <el-col :span="16">
                <el-form-item label="Title">
                  <el-input
                    placeholder="Page title"
                    v-model="form.contents[locale].title"
                    clearable=""
                  ></el-input>
                </el-form-item>
              </el-col>
              <el-col :span="8">
                <el-form-item label="Menu item" required>
                  <el-input
                    placeholder="Menu"
                    v-model="form.contents[locale].name_in_menu"
                    clearable=""
                  ></el-input>
                </el-form-item>
              </el-col>
            </el-row>

            <Editor v-model="form.contents[locale].content"></Editor>
          </el-tab-pane>
          <el-tab-pane label="SEO">
            <el-form-item label="Title" required>
              <el-input
                v-model="form.contents[locale].seo.title"
                placeholder="Title"
                clearable=""
              ></el-input>
            </el-form-item>

            <el-form-item label="Description">
              <el-input
                placeholder="Description"
                type="textarea"
                :rows="3"
                v-model="form.contents[locale].seo.description"
                clearable=""
              ></el-input>
            </el-form-item>

            <el-form-item label="Keywords">
              <el-input
                placeholder="Keywords"
                type="textarea"
                :rows="3"
                v-model="form.contents[locale].seo.keywords"
                clearable=""
              ></el-input>
            </el-form-item>
          </el-tab-pane>
          <el-tab-pane label="Blocks">
            <el-collapse v-model="blocksModel">
              <draggable
                ghost-class="ghost"
                v-model="form.contents[locale].pages_contents_blocks"
                :disabled="blocksModel.length > 0"
              >
                <el-collapse-item
                  v-for="(item, index) in form.contents[locale]
                    .pages_contents_blocks"
                  :key="index"
                  :name="index"
                >
                  <template #title>
                    <div class="block-title">
                      <div>
                        <el-tag
                          :type="item.hash ? 'info' : 'danger'"
                          style="margin-right: 8px"
                        >
                          {{ item.hash || 'required' }}
                        </el-tag>
                        {{ item.menu_label || item.title || 'No title' }}
                      </div>
                      <div>
                        <el-checkbox style="margin-right: 0px" size="small" v-model="item.active"></el-checkbox>
                        <el-button
                          type="danger"
                          plain=""
                          size="mini"
                          @click.stop="
                            deleteBlock(
                              item,
                              form.contents[locale].pages_contents_blocks
                            )
                          "
                        >
                          Delete
                        </el-button>
                      </div>
                    </div>
                  </template>
                  <div class="block-item">
                    <el-row :gutter="24">
                      <el-col :span="8">
                        <el-form-item label="Menu label">
                          <el-input
                            placeholder="Menu label"
                            v-model="item.menu_label"
                            clearable=""
                          ></el-input>
                        </el-form-item>
                      </el-col>
                      <el-col :span="8">
                        <el-form-item label="Hash" required>
                          <el-input
                            placeholder="Hash unique identifier"
                            v-model="item.hash"
                            clearable=""
                          ></el-input>
                        </el-form-item>
                      </el-col>
                      <el-col :span="8">
                        <el-form-item label="Url">
                          <el-input
                            v-model="item.menu_link"
                            clearable=""
                          ></el-input>
                        </el-form-item>
                      </el-col>
                    </el-row>
                    <el-form-item label="Title">
                      <el-input
                        placeholder="Page title"
                        v-model="item.title"
                        clearable=""
                      ></el-input>
                    </el-form-item>
                    <Editor
                      v-model="item.content"
                      style="margin-top: 15px"
                      v-if="blocksModel.indexOf(index) > -1"
                    />
                  </div>
                </el-collapse-item>
              </draggable>
            </el-collapse>

            <el-button
              type="primary"
              @click="addBlock(form.contents[locale])"
              class="add-block"
            >
              Add
            </el-button>
          </el-tab-pane>
        </el-tabs>
      </el-tab-pane>
    </el-tabs>

    <div style="margin-top: 24px; display: flex; align-items: center">
      <el-button type="success" native-type="submit" style="margin-right: 15px">
        Save
      </el-button>
      <el-checkbox border v-model="form.active">Active</el-checkbox>
    </div>
  </el-form>
</template>

<script lang="ts">
import { defineComponent, reactive, ref } from '@nuxtjs/composition-api'
import {
  Locales_Enum,
  FullPageFragment,
  Pages_Contents_Update_Column,
  Pages_Contents_Blocks_Update_Column,
  Pages_Contents_Blocks_Insert_Input,
  Pages_Contents_Blocks_Constraint,
  Pages_Constraint,
  Pages_Update_Column,
  Pages_Contents_Constraint,
  Seo_Constraint,
  Seo_Update_Column,
  PageContentBlockFragment
} from '@/sdk/types'

import { keyBy, omit } from 'lodash'
import draggable from 'vuedraggable'
import {
  useAdminUpdatePageMutation,
  useAdminDeletePageContentBlockMutation
} from '~/sdk/hooks'

export default defineComponent<{
  value: FullPageFragment
}>({
  name: 'AdminPagesForm',
  props: ['value'],
  components: {
    draggable,
    Editor: () => import('../Editor.vue')
  },
  setup({ value }, { root }) {
    function makeForm(value: FullPageFragment) {
      return reactive({
        ...value,
        contents: reactive(
          keyBy(
            value.pages_contents.map(c => ({
              ...c,
              seo: c.seo || {}
            })) || [],
            'locale'
          )
        )
      })
    }

    const form = ref(makeForm(value))

    const activeTab = ref('_en')

    function createTranslation(locale: Locales_Enum) {
      root.$set(form.value.contents, locale, {
        locale,
        seo: {},
        name_in_menu: '',
        content: '',
        pages_contents_blocks: []
      })
    }

    const { mutate, onError, loading } = useAdminUpdatePageMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    onError(err => {
      root.$message.error(err?.message || 'error')
    })

    async function onSubmit() {
      const data = form.value

      const result = await mutate({
        object: {
          ...omit(
            data,
            'contents',
            'pages_contents',
            'created_at',
            'updated_at',
            '__typename'
          ),
          slug: data.slug.startsWith('/') ? data.slug : `/${data.slug}`,
          pages_contents: {
            data: [
              ...Object.values(data.contents).map(c => ({
                ...omit(c, [
                  'created_at',
                  'updated_at',
                  'pages_contents_blocks',
                  'seo',
                  'page_id',
                  '__typename'
                ]),
                seo: {
                  data: omit(c.seo, ['__typename']),
                  on_conflict: {
                    constraint: Seo_Constraint.SeoPkey,
                    update_columns: [
                      Seo_Update_Column.Title,
                      Seo_Update_Column.Description,
                      Seo_Update_Column.Keywords,
                      Seo_Update_Column.Image
                    ]
                  }
                },

                pages_contents_blocks: {
                  data: c.pages_contents_blocks.map((b, order) => {
                    return {
                      ...omit(b, [
                        'created_at',
                        'updated_at',
                        '__typename',
                        'page_content_id'
                      ]),
                      hash:
                        b.hash ||
                        `${data.slug.replace('/', '')}-block-${order}`,
                      order
                    }
                  }),
                  on_conflict: {
                    constraint:
                      Pages_Contents_Blocks_Constraint.PagesBlocksPkey,
                    update_columns: [
                      Pages_Contents_Blocks_Update_Column.Content,
                      Pages_Contents_Blocks_Update_Column.Hash,
                      Pages_Contents_Blocks_Update_Column.Order,
                      Pages_Contents_Blocks_Update_Column.Title,
                      Pages_Contents_Blocks_Update_Column.MenuLabel,
                      Pages_Contents_Blocks_Update_Column.MenuLink,
                      Pages_Contents_Blocks_Update_Column.Active
                    ]
                  }
                }
              }))
            ],
            on_conflict: {
              constraint: Pages_Contents_Constraint.PagesContentsPkey,
              update_columns: [
                Pages_Contents_Update_Column.Locale,
                Pages_Contents_Update_Column.Content,
                Pages_Contents_Update_Column.NameInMenu,
                Pages_Contents_Update_Column.Title
              ]
            }
          }
        },
        on_conflict: {
          constraint: Pages_Constraint.PagesPkey,
          update_columns: [
            Pages_Update_Column.Data,
            Pages_Update_Column.Name,
            Pages_Update_Column.Slug,
            Pages_Update_Column.Active
          ]
        }
      })
      if (!result.data?.page) return
      form.value = makeForm(result.data.page)
    }

    function addBlock(data: {
      pages_contents_blocks: Pages_Contents_Blocks_Insert_Input[]
    }) {
      data.pages_contents_blocks.push({
        hash: '',
        content: ''
      })
    }

    const {
      mutate: deleteBlockMutate
    } = useAdminDeletePageContentBlockMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    function deleteBlock(
      item: PageContentBlockFragment,
      blocks: PageContentBlockFragment[]
    ) {
      root.$confirm(`Delete block ${item.title || item.hash}?`, {
        type: 'warning',
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        center: true,
        async callback(action) {
          if (action === 'confirm') {
            if (item.id) {
              await deleteBlockMutate({ id: item.id })
            }
            blocks.splice(blocks.indexOf(item), 1)
          }
        }
      })
    }

    const blocksModel = ref([])

    return {
      form,
      activeTab,
      createTranslation,
      onSubmit,
      loading,
      addBlock,
      deleteBlock,
      blocksModel,
      locales: {
        ...Locales_Enum
      }
    }
  }
})
</script>

<style lang="scss">
.block-item {
  .el-collapse {
    margin-top: 16px;
  }
  .ck-editor__editable {
    min-height: 150px;
  }

  .el-collapse-item__header {
    padding-left: 15px;
  }

  &__item {
    padding: 0 15px;
  }
}
.add-block {
  margin: 24px 0;
}
.block-title {
  display: flex;
  justify-content: space-between;
  flex: 1;
  padding-right: 16px;
}
</style>
